%ASIMUL.M, a script file
%   ASIMUL constructs a random simulation of length t1 for a recursive
%   linear equilibrium model.  The outputs of SOLVEA as well as the
%   matrix sy and the integer t1 must be in memory.
%   The equilibrium is
%
%     x(t+1) = ao*x(t) + c*w(t+1)
%
%   A vector of observables is given by
%
%       y(t) = sy*x(t)
%
%   where sy is to be specified by the user.  If we want y=[c',i']',
%   we set sy=[sc;si], where sc and si are among the outputs of
%   SOLVEA.  ASIMUL computes a simulation of y of length t1 and stores
%   the output in the matrix y.
t=0:(t1-1);
										
										

k=1;  % Set k = 1 for a random simulation, k=2 for a nonrandom simulation.

    if k == 1;


    u=randn(t1,nw);

    end;

    if k == 2;

    u=zeros(t1,nw);

    end;


    [rd,dd]=size(sy);


y=dlsim(ao,c,sy,zeros(rd,nw),u,x0);

disp('   ')
disp('Your simulated vector is in the vector "y". ')
disp('   ')

