%  Creates matrices for an economy with technology 3 and
%  preference specification 2.
%  Technology 3 is the multi-period adjustment costs or
%  "time to build" techology.
%  Preference specification 3 is the "habit persistence"
%  specification.  We have modified the preference specification
%  to make utility depend on the difference between consumption
%  and a geometric distributed lag of consumption four, eight, ...
%  periods ago.
%  The parameters of phi and gamma (=gam) are to be specified
%
%  We have set things up to have a seasonal preference shock
%  and a first order a.r. technology shock.
phi=[1 .8 3 1]
gam=.1
deltak=[.95 1 ; 0 0]
thetak=eye(2)
phic=[1 0 0 0 0]'
phig=[0 0 0 0;-eye(4)]
phii=[0 0;phi(1) phi(2);phi(2) 0; phi(3) 0;0 phi(4)]
gamma=[gam 0; 0 0; 0 -phi(2);0 0 ; 0 0]
deltah=[0 0 0 .9;1 0 0 0; 0 1 0 0; 0 0 1 0]
lambda=[-.8 0 0 0]
thetah=[.1 0 0 0]'
pih=1;
										
beta=1/1.05;
a22=[1 0 0 0 0 0;0 0 0 0 .7 0; 0 1 0 0 0 0;0 0 1 0 0 0;0 0 0 1 0 0;...
   0 0 0 0 0 .8]
c2=[0 0;1 0;0 0;0 0; 0 0; 0 .5]
ud=[5 0 0 0 0 1]
ud=[ud;zeros(4,6)]
ub=[30 1 0 0 0 0]
x0=[20.97 20.97 20.97 20.97 158.94 7.23 1 0 0 0 0 0]'
