% Dec7.m         Does some calculations for twodiff2.m
%
%
%   Couples the systems
%
%        x(t+1) = ao * x(t) + c * w(t+1)
%          y(t) = sy * x(t)
%
%        xh(t+1) = (ao-k1*GG) * xh(t) + k1 * y(t)
%          u(t)  = - GG * xh(t) + u(t)
%
%    where w(t+1) is the innovation to agents' info sets and where
%    u(t) is the fundamental (Wold) representation innovation.
%    The program computes the impulse response of u(t) to w(t), and
%    stores the results in y1 and y2.  If y1 and y2 are concentrated
%    at zero lag, there is not the first of "two difficulties".
[m1,n1]=size(c);
[m2,n2]=size(sy);
d=zeros(m2,n1);
aa=ao-k1*GG;
bb=k1;cc=-GG;
[m1,n1]=size(bb);
[m2,n2]=size(GG);
dd=eye(2);
[AA,BB,CC,DD]=series(ao,c,sy,d,aa,bb,cc,dd)
y1=dimpulse(AA,BB,CC,DD,1,20)
y2=dimpulse(AA,BB,CC,DD,2,20)

