function [v,p]=flip(G,see)
% function [v,p]=flip(G,see)
% Takes moving average kernel G =[G(0) G(1) . . . G(n)] with
% variance see, and produces moving average kernel
% p=[p(0) p(1) ... p(n)] with variance v.  The kernel p has
% its roots all inside the unit circle, and so is associated
% with the Wold representation.

n=length(G);
g=polystab(G);
G1=G(n:-1:1);
g1=g(n:-1:1);
gc=conv(g,g1);
Gc=conv(G,G1);

rat=Gc./gc;

p=g;
v=rat(1)*see;


