%  jan25.m
%  computes graph for determining equilibrium R, c for
%  Townsend model with seignorage
beta=.95;
g=.51;


%  u(c) = c^(1-delta)/(1-delta)

delta=3.5;   %logarithmic case

c=[.25:.01:1-g];
s=ones(1:length(c));
rhs=(c./((1-g)*s- c)).^(-delta);
lhs=beta*((1-g)*s-c)./(s-c);
lhs=lhs';
rhs=rhs';
plot(c',lhs),pause
plot(c',rhs),pause
plot(c,[lhs rhs]),pause


