% jov2.m  (modified version, to work with mkv2.m- requires m parameter)
%Prof. Sargent,
%  run dist.m to compute wage distributions
%
%Here is the program you requested.  It calls a function 'mkv.m'
%which computes the transition matrix P_t. This function  follows the
%program in this email message.
%
%
% This program uses the methods of discrete state discounted dynamic 
% programming to solve the problem of a worker in the 'finite search'
% environment described by Prof. Sargent
%

n=60;			%number of discrete points of wage dist
t=20;			%number of time periods where 'matching' goes on

m=6;                    %number of points in wage grid that Markov process
                        %skips 

q=.5;			%probability from transition matrix
v=zeros(n,t+1);		%discretized value function matrix
dec=zeros(n,t+1);	%discr. decision rule matrix-1=accept,2=reject
tdec=zeros(n,t+1);
mu=ones(n,1)*1/n;	%initial wage distribution
minw=0;
maxw=9;
w=linspace(minw,maxw,n)';  %discretized wage offer interval
beta=.98;
ibar=ones(n,1);
maxiter=50;
count=0;
done=0;

while done==0 & count<maxiter

[temp1,temp2]=max([w*inv(1-beta) beta*kron(mu'*v(:,1),ibar)]');
v(:,t+1)=temp1';
tdec(:,t+1)=temp2';

for j=1:t,
 i=t+1-j;
 [temp1,temp2]=max([w+beta*mkv2(q,i,n,m)*v(:,i+1) beta*kron(mu'*v(:,1),ibar)]');
 v(:,i)=temp1';
 tdec(:,i)=temp2';
end

count=count+1;
if tdec==dec,
 done=1;
end
dec=tdec;  

end

dec

for i=1:t+1,
 for j=1:n-1,
   if dec(j,i)-dec(j+1,i)>0
     reswage(i)=w(j+1);
     rho(i)=j+1;
   end
 end
end

reswage=reswage'

return


function P=mkv2(q,t,n,m);

P=zeros(n,n);
P(1,1)=1-(q^t);   P(1,2)=q^t;
P(n,n)=1-(q^t);   P(n,n-1)=q^t;
for j=2:n-1;
  P(j,j)=1-2*(q^t);  P(j,j-1)=q^t;  P(j,j+1)=q^t;
end






