function[value]=prev(y,beta)
%function[value]=prev(y,beta)
%pv.m
%  Computes present value of moving average coefficients
%  beta is the discount factor to be used
%  y is the vector of moving average coefficients
%  n is the length of the moving average over which the present value
%  is calculated
n=max(size(y));
j=[1:n]';
b=beta.^j;
v=y.*b;
value=sum(v);
value=value + y(n)*beta^(n+1)/(1-beta);
