%@ This is the Matlab version of Gary's Gauss program that solves a simple
%  version of Ayse's JPE model with an iid shock. @
%new;
ts=clock;
sigma=1.5;    %@ risk aversion              @
beta=0.98;    %@ subjective discount factor @
prob=0.75;    %@ probability of employment  @
maxast=10;     %@ maximum value of assets    @
incast=0.25; %@ size of asset increments; so maxast/incast=40; plus 1 for 0=41
theta=0.25;   %@ income when unemployed     @

nasts=round(maxast/incast+1);
util1=-10000*ones(nasts,nasts);  %@ utility when employed     @
util2=-10000*ones(nasts,nasts);  %@ utility when unemployed   @

%@ tabulate the utility function such that for zero or negative
%  consumption utility remains a large negative number so that
%  such values will never be chosen as utility maximizing      @

i=1;

while i <= nasts;
         asset=(i-1)*incast;
            j=1;
              while j < round(i+1/incast) & j <= nasts;
                 assetp=(j-1)*incast;
                 util1(j,i)=(1+asset-assetp)^(1-sigma)/(1-sigma);
                 j=j+1;
              end;
              j=1;
              while j < round(i+theta/incast) & j <= nasts;
                  assetp=(j-1)*incast;
                  util2(j,i)=(theta+asset-assetp)^(1-sigma)/(1-sigma);
                  j=j+1;
               end;
       i=i+1;
end;


v=zeros(nasts,2);
decis=zeros(nasts,2);
test=10;
iter=0;

%@ iterate on Bellman's equation and get the decision rules and the
%  value function at the optimum         @

[rs,cs]=size(util1);


%iter=1;
 while test ~= 0;


    for i=1:cs;
         r1(:,i)=util1(:,i)+beta*(prob*v(:,1)+(1-prob)*v(:,2));
         r2(:,i)=util2(:,i)+beta*(prob*v(:,1)+(1-prob)*v(:,2));
    end;

[tv1,tdecis1]=max(r1);
tv1=tv1';
tdecis1=tdecis1';

[tv2,tdecis2]=max(r2);
tv2=tv2';
tdecis2=tdecis2';

tdecis=[tdecis1 tdecis2];
tv=[tv1 tv2];

         test=max(any(tdecis-decis));
         v=tv;
         decis=tdecis;
         iter=iter+1;
end;

et=etime(clock,ts);
decis=(decis-1)*incast;























