function [spec,f,cc]=spectr3(b,a,n)
%function [spec,f,cc]=spectr3(b,a,n)
%   Computes spectral density and covariogram of a rational
%   univariate process using classical methods.
%   The process is
%
%        a(L)x(t) = b(L)*e(t)
%
%   where e(t) is a white noise with unit variance;a(L) and b(L)
%   are entered as
%
%        [1 -a1 -a2 -.... -an]
%
%        [b0 b1 b2 ... bm]
%   The integer n is the number of ordinates at which the spectrum
%   is calculated; n must be an integer power of 2.
%   The spectrum and frequencies are stored in "spec" and "f", respectively.
%   The autocovariogram is stored in "cc".
st='spectrum';
										
[spec,f]=show(b,a,n,st);
c=ifft(spec);
nt=(n/2 -1);
index=[0:nt];
plot(index,real(c(1:nt+1))),title('covariogram'),pause
cc=real(c(1:nt+1))';f=f';spec=spec';
