% farm.m
% A version of Rosen-Murphy-Scheinkman model

g=.85;
beta=.909;
delta=.1  ;

gamma0=.4;     %  food factor for a calf
gamma1=.7;     %  food factor for a yearling

lambda=0; deltah=0;
thetah=0;



alpha0=500;
alpha1=.01;

pih=sqrt(1/alpha1);     %  check this  alpha1=pih^{-2}


deltak=[(1-delta) 0 g; 1 0 0; 0 1 0];
thetak=[1 0 0 ]';


%  f5, f6 are f1,f2 in the text.  The remaining are moved up two.


f5=.001;
f6=1/(2*f5);
f1=.001;
f2=gamma1*g/(2*f1);
f3=.001;
f4=gamma0*g/(2*f3);
f7=.001;
f8=1/(2*f7);


phic=[1 f5 0 0 -f7]';
phii=[1 0 0 0 0]';
phig= [0 0 0 0; 1 0 0 0; 0 1 0 0; 0 0 1 0; 0 0 0 1];
gamma=[0 0 0; f5*(1-delta) 0 g*f5; f1 0 0; 0 f3 0; 0 0 0];

rho1=0;
rho2=0;
rho3=.6;

a22=[1 0 0 0; 0 rho1 0 0; 0 0 rho2 0; 0 0 0 rho3];

c2=[0 0 0; 1 0 0; 0 1 0; 0 0 25];

% c2=[0 0 0; 0 0 0; 0 0 0; 0 0 100];

%  The first z is h, the second is m, the third is the demand shock.

uh=[100 1 0 0];      %  Holding costs
um=[30 0 1 0];      %  Feeding costs
% udd=[500 0 0 1] ;    %  Demand curve

ud=[ 0 0 0 0; f6*uh; f2*uh; f4*uh; f8*um];




% alpha0=500/pih;
% alpha1=1/pih;

ub=[pih*alpha0 0 0 pih ];

