function[num,den]=aarma(ao,c,sy,i)
%function[num,den]=aarma(ao,c,sy,ii)
%  Creates ARMA Representation for linear recursive equilibrium
%  models.  The equilibrium is
%     x(t+1) = ao*x(t) + c*w(t+1)
%  and is created by running SOLVEA.  A vector of observables is given by
%
%      y(t) = sy*x(t)
%  where sy picks off the desired variables.  For example, if we want
%  y=[c',i'], we set sy=[sc;si].  AARMA creates the representation
%
%     den(L)y(t) = num(L)wi(t)
%  This is an arma representation for the response of y(t) to the i-th
%  component of w(t).
[m1,n1]=size(c);
[m2,n2]=size(sy);
d=zeros(m2,n1);
[num,den]=ss2tf(ao,c,sy,d,i);
