function [f,p] = expricc1(a,b,c,r,q,sig,beta)
%function [f,p] = expricc1(a,b,c,r,q,sig,beta)

%DLQR   Linear quadratic regulator design for discrete-time systems.
%       [K,S] =EXPRICC(A,B,Q,R)calculates the optimal feedback gain matrix
%
%
%		u = -Kx
%
%	minimizes the cost function:
%
%		J = Sum {x'Qx + u'Ru}
%
%	subject to the constraint equation: 
%		
%		x[n+1] = Ax[n] + Bu[n] 
%                
%	Also returned is S, the steady-state solution to the associated 
%	discrete matrix Riccati equation
%					    
%	 The algorithm iterates on the matrix Riccati difference equation
[m,n]=size(a);
[mb,nb]=size(b);
[mc,nc]=size(c);

 p0=.1*eye(m);
 tol=.00000001;
 dd=1;
 while dd>tol;
p1=p0+sig*p0*c*((eye(nc)-sig*c'*p0*c)\c'*p0);
f=(1*q+beta*b'*p1*b)\(beta*b'*p1*a);
p2=1*r+1*f'*q*f+beta*(a-b*f)'*p1*(a-b*f);
%  notice the following amendment

p2=p2/1;
 dd=max(max(abs(p2-p0)));
p0=p2;
 end
p=p0;
str=('the closed loop system matrix a-b*k is')
 gg=a-b*f
 str; gg
