function [g]=fold(f,p)
%function [g]=fold(f,p)
%  This program applies the `folding formula' to a complex
%  valued vector f, where p is a positive integer that determines
%  the folding interval.  The length of f must be an integer
%  multiple of p.
%
%  Note: the original frequencies are 2 pi j/ T, for j = 0, . . . , T-1;
%  the new frequencies are 2 pi h /(T/p) for h = 0, ..., pT-1.
T=length(f);
g=zeros(1:T/p);
for j=1:p
g=g+f((j-1)*T/p +1:j*T/p); 
end 


