%  FORECASF.M
%  Uses frequency domain method to implement a version of the
%  Hansen-Sargent formula for the linear least squares forecast
%  of a geometric distributed lead of a univariate arma process.
%
%  The program prompts the user for a and b, both of which must be
%  vectors of the same length.  a=[a0 ... am], b=[b0 ... bm],
%  where
%       Sum aj*x(t-j) = Sum bj*a(t-j)
%
%  where {a(t)} is a white noise process with unit variance.  The program
%  also prompts the user for lam, which is the decay factor in the
%  geometric distributed lead
%     E Sum (lam)^j * x(t+j) = Sum bb(j) * x(t-j)
%
%  The program returns the vector bb=[bb0 ... bbr].
%
%  We enter a(L) and b(L) as polynomials, pad them out with 100
%  zeros, then take their fft to get a(w) and b(w).  We also
%  form lam(w) using this method.  Then we form
%  b(w)/(a(w)*lam(-w)), and take its inverse fft.  Then we lop off
%  the coefficients (n+1:2n), which correspond to negative powers of L
%  and take the fft of the result.  We then multiply this by
%  a(w)/b(w) and inverse fft to obtain the final "Hansen-Sargent" coefficients.
a=input('give a ')
b=input('give b ')
lam=input('give geometric term lamda ')
n=input('give value of n, number of zeros in pad')
a=[a';zeros(n,1)];
b=[b';zeros(  n,1)];
fa=fft(a);
fb=fft(b);
fr=fb./fa;
ns=length(a);
llam=[1 -lam]';
llam=[llam;zeros(ns-2,1)];
flam=fft(llam);
frat=fr./conj(flam);
h=ifft(frat);
hh=real(h);
no=max(size(hh));
hhh=hh;hhh(no/2+2:no)=zeros(no/2-1,1);
plot(hhh),title('coeffs on innovs to y for forming geom sum'),pause
fhhh=fft(hhh);
s=abs(fhhh);nn=max(size(s));f=2*pi*(0:nn-1)/nn;
semilogy(f,s),title('freq response of geom sum'),pause
k=ifft(fhhh.*fa./fb);
kk=real(k);
plot(kk),title('coefficients on y s for forming geom sum'),pause
kk(1:10)
bb=kk(1:20);
%bb is the vector of coefficients giving the geometric sum
%of future y's as a function of current and lagged y's
bb
