function[sx,f,d,jj]=larry2(x,y,sm,nn)
%function[sx,f,d,jj]=larry2(x,y,sm,nn)
%   This program calculates the cross spectrum s of series x and y at the
%   frequencies f, using the smoother sm. The cross-covariogram is also
%   calculated.  A trapezoidal taper of length nn is used.
%   The cross spectrum is returned in sx, with the frequencies stored in f.
%   The cross-covariogram is returned in d, with the "lag" corresponding
%   to d being returned in jj.  To see amplitude of the cross-spectrum, issue
%   the command semilogy(f,real(sx)).  To see the cross-covariogram, issue the
%   command plot(jj,d).
%   The smoother is stored in sm.  E.g., for a box smoother, use
%     sm=[1 1 1 . . .  1 1]/mm
%   where mm is the number of elements in sm.  The parameter nn governs
%   the length of the taper.
mm=mean(x);x=x-mm;
x=taper(x,nn);y=taper(y,nn);
f=fft(x);g=fft(y);
ix=f.*conj(g);
s1=length(x);
s2=length(sm);
s3=(s2-1)/2;
s4=s3+1;
iz=[ix(s4:-1:2);ix;ix(1:s4)];
s=conv(iz,sm);
s7=length(s);
r1=length(iz);
r2=r1-s1;
s8=(s7-s1-1)/2;
sx=s(s8+1:s7-s8);
n=length(x);
f=2*pi*(0:n)'/n;
semilogy(f,abs(sx)),title('amplitude of cross spectrum'),pause
plot(f,imag(sx)),title('imaginary part of cross spectrum'),pause
c=real(ifft(2*sx/n));
nn=max(size(c));
n=nn/2;
jj=[(-n:-1),(0:n-1)]';
										
										
d=[c(n+1:2*n);c(1:n)];
										
