
% pure prediction problem solver
% For a state space system 
%  x_{t+1} = A x_t + C w_{t+1}  , E w w' = I
% and an observed or target variable z_t = H x_t,
% this solves for the worst case shocks by iterating to
% convergence on S(V) where
% S(V) = - H'*H + beta A' D(V) A and
%
% D(V) = V + sig*V*C (I - sig*C'*V*C)^{-1} *C'*V
% It returns the M in the worst case shock formula
%
%  M = sig*(I - sig*C'V*C)^{-1}*C*V

sig=-.001;
beta=.96;
A=.98;
C=1;
H=1;

%A =[.9 .05;
%   1 0 ];

%C=[1 0]';

%H=[1 0];


[rc,cc]=size(C);
eyeC=eye(cc);
v0=zeros(size(A));

dd=10;
tol=.000005;


while dd>tol
   d1=v0+sig*(v0*C/(eyeC - sig*C'*v0*C))*C'*v0;
   
   v1=-H'*H + beta* A'*d1*A;
   
   dd=max(max(abs(v1-v0)));
   
   v0=v1;
   
end

%  formula for worst case shock is w_{t+1} = M x_t where

M = (sig/(eyeC-sig*C'*v1*C))*C'*v1

% formula for worst case transition function

Ahat = A + M*C

%  Now find the formulas for the pricing formula
%
%  p= H*(I -beta*Ahat)^{-1} x_t 


eyeA = eye(length(A));

Pmulthat = H/(eyeA - beta*Ahat)  % for robust case

Pmult = H/(eyeA -beta*A)    % for ordinary case

% final value function

v1