%SIMDH.m  a script file (not a function)
%  DISTHET must be run first before running SIMDH.  Also the number of
%  simulating periods, T, must be set beforehand.  
%
%  SIMDH simulates the current deficits and the expected present 
%  discounted budgets of the two types of households and the government.
%  
rand('seed',0)
% First version, Jan. 19, 1993.

rand('normal');
[nx,nw]=size(C);
[nk, nx]=size(sk);
[nh,nc]=size(Thetah1);
e1=ones(1,nc)*mc;
v=beta/(1-beta)*doublej2(beta*Ao,C,Ao,C);

        % computing the current deficit kernel Zg.  Government's current
        % deficit at date t is: x(t)'*Zg*x(t) (Assume Ti(t) always
	% equal to 0).  The kernels for the two households are Z1 and Z2.
    
	%    Za=(md'*GammaK+Muk'*DeltaK)*sk;
	%    Z1=mc'*nettauc*sc1+nettaul*mu01/mu*md'*Phig*sg-md'*sd1-f1*Za;
	%    Z2=mc'*nettauc*sc2+nettaul*mu02/mu*md'*Phig*sg-md'*sd2-(1-f1)*Za;

Zg=mc'*tauc*(sc1+sc2)+taul/(1-taul)/(mu01+mu02)*sg'*sg+mi'*taui*si-mc'*se...
   +mk'*tauk*[zeros(nk,nx-nk), eye(nk)];

	% computing the kernels of budget balances B1, B2, and Bg.
	% balancea=x0'*(mk'*nettauk+Muk'*Deltak);
balancet=mk'*(eye(nk)-tauk)+Muk'*Deltak;
B1=doublej2(beta*Ao',Z1,Ao',1); Sig1=sum(diag(Z1*v));
B2=doublej2(beta*Ao',Z2,Ao',1); Sig2=sum(diag(Z2*v));
Bg=doublej2(beta*Ao',Zg,Ao',1); Sigg=sum(diag(Zg*v));

for t=1:T
%  current1(t)=x0'*Z1*x0;
%  current2(t)=x0'*Z2*x0;
  currentg(t)=x0'*Zg*x0;
%  budget1(t)=(x0'*B1*x0+Sig1-x0'*balancet*diag(k01./(k01+k02))*...
%    x0(nx-nk+1:nx))/(e1*x0);
%  budget2(t)=(x0'*B2*x0+Sig2-x0'*balancet*diag(k02./(k02+k01))*...
%    x0(nx-nk+1:nx))/(e1*x0);
  budgetg(t)=(x0'*Bg*x0+Sigg)/(e1*x0);
  w=rand(nw,1);
  x=Ao*x0+C*w;
  x0=x;
end

disp(' ')
disp('The current deficits of type 1, 2 and government are stored in current1,')
disp('current2 and currentg; the budgets are in budget1, budget2, budgetg.')
disp('The kernel matrices for current deficits are Z1, Z2, Zg, the kernel')
disp('matrices for budgets are B1, B2, Bg, and the corresponding risk premium')
disp('terms are Sig1, Sig2, Sigg.')

echo on

%pause %hit a key to see the simulation of current deficits...
%plot(1:T, [current1; current2; currentg]),pause

%pause %hit a key to see the simulation of budgets...
%plot(1:T, [budget1;budget2; budgetg]),pause

plot(budgetg) ,title('bonds'),pause

plot(currentg),title('deficit'),pause


echo off


