%  simsex.m
%  Creates example from Sims seasonality paper
%  Computes nth order a.r. representation for a process
%  that is the sum of a deterministic process and an a.r. process.
%  Note that two `weight' parameters are specified, and that
%  things are set up to compute for a 12th order a.r.

m=12;
t=[0:m-1]';
b=.9.^t;    %creates covariogram of first order a.r., parameter .9;
v1=toeplitz(b);     %  covariance matrix of indeterministic part.

g=1/sqrt(2);
d=[g 0 -g 0 g 0 -g 0 g 0 -g 0]';  % edit this line if n doesn't equal 12

v2=d*d';       %  covariance matrix of deterministic part

var=1/(1-.9^2);   %variance of a.r. part

weight1=1;   %  weight on a.r. part
weight2=1;  %  weight on deterministic part

v=weight1*v1+weight2*v2;        %  covariance matrix of sum

xy=v(1,2:m)';    % the x'y vector
xx=v(2:m,2:m);    %  the x'x  matrix

aa=xx\xy;
a=[1 -aa'];       %  the polynomial in lag operator for the a.r.

b=1;
n=2^8;
st='spectral density of sum';
show(b,a,n,st);     %  compute spectral density of sum

%         redo the calculation for m=9;

m=9;

xy=v(1,2:m)';    % the x'y vector
xx=v(2:m,2:m);    %  the x'x  matrix

aa=xx\xy;
a=[1 -aa'];       %  the polynomial in lag operator for the a.r.

b=1;
n=2^8;
st='spectral density of sum';
show(b,a,n,st);     %  compute spectral density of sum
