
% Vaughan.m
% beta=1; phi1=-1; phi0=2.000001;
crit=1/sqrt(beta);
% M1=[beta*phi1 phi0; 0 1];
% M2=[0 -phi1; 1 0];

% nx=4;
jj=1;
% M1 and M2 are the Vaughan's matrices that satisfy: 
%        M1*[x(t+1);mux(t+1)]=M2*[x(t);mux(t)]

%--------part IV: Vaughan's Method to find stable solution----------------
% for more about Vaughan's method, please refer to Chapter XX of Hansen and
% Sargent: XXXXXXXXXXX

    [W,D]=eig(M2,M1);     % W: matirx of generalized eigenvectors
    diagV=diag(D);        % D: diagonal matrix of generalized eigenvalues
    if jj==1
      ds=sum(diagV<crit);
      if ds<nx            % stable subspace too small
        disp('WARNING: Competitive equilibrium may not exist')
      elseif ds>nx        % stable subspace too large
        disp('Warning: May exist other competitive equilibria')
      end
    end
    [absd,order]=sort(abs(diagV));     % arrange eigenvectors, eigenvalues in 
    W=W(:,order);                      % order of absolute values of 
    D=diag(diagV(order));              % eigenvalues.		
    V=inv(W);
    M=W(nx+1:2*nx,1:nx)/W(1:nx,1:nx); M=real(M);

	% M is the costate policy function: mux(t)=M*x(t)

    VV=V(1:nx,1:nx)+V(1:nx,nx+1:2*nx)*M;
    Ao=W(1:nx,1:nx)*D(1:nx,1:nx)*VV; Ao=real(Ao);
%    C=[C2; C2; zeros(2*nh+nk,nw)]; C=real(C);

	% Ao and C are the closed loop solution of the states of the economy:
        % 	 x(t+1)=Ao*x(t)+C*w(t+1)

